Imports System.Threading

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnStartThread As System.Windows.Forms.Button
    Friend WithEvents btnStopThread As System.Windows.Forms.Button
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnStartThread = New System.Windows.Forms.Button
        Me.btnStopThread = New System.Windows.Forms.Button
        Me.TextBox1 = New System.Windows.Forms.TextBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'btnStartThread
        '
        Me.btnStartThread.Location = New System.Drawing.Point(16, 64)
        Me.btnStartThread.Name = "btnStartThread"
        Me.btnStartThread.Size = New System.Drawing.Size(80, 23)
        Me.btnStartThread.TabIndex = 0
        Me.btnStartThread.Text = "Start Thread"
        '
        'btnStopThread
        '
        Me.btnStopThread.Enabled = False
        Me.btnStopThread.Location = New System.Drawing.Point(144, 64)
        Me.btnStopThread.Name = "btnStopThread"
        Me.btnStopThread.Size = New System.Drawing.Size(80, 23)
        Me.btnStopThread.TabIndex = 1
        Me.btnStopThread.Text = "Stop Thread"
        '
        'TextBox1
        '
        Me.TextBox1.Location = New System.Drawing.Point(8, 96)
        Me.TextBox1.Multiline = True
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.Size = New System.Drawing.Size(232, 104)
        Me.TextBox1.TabIndex = 2
        Me.TextBox1.Text = ""
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(232, 48)
        Me.Label1.TabIndex = 3
        Me.Label1.Text = "Note that you can interact with the program (for example, type in the TextBox) wh" & _
        "ile the thread is running."
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(248, 205)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.TextBox1)
        Me.Controls.Add(Me.btnStopThread)
        Me.Controls.Add(Me.btnStartThread)
        Me.Name = "Form1"
        Me.Text = "howto_net_pause_thread"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' Keep track of the thread so we can control it.
    Private m_Thread As Thread

    ' This value is incremented by the thread.
    Public Value As Integer = 0

    ' Make the thread but don't start it yet.
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make a new counter object.
        Dim new_counter As New Counter(Me)

        ' Make the thread to run the object's Run method.
        m_Thread = New Thread(AddressOf new_counter.Run)

        ' Make this a background thread so it automatically
        ' ends when the form's thread ends.
        m_Thread.IsBackground = True

        btnStopThread.Enabled = False
        btnStartThread.Enabled = True
    End Sub

    ' Start the thread.
    Private Sub btnStartThread_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartThread.Click
        Debug.WriteLine("Starting thread")
        If (m_Thread.ThreadState And ThreadState.Unstarted) <> 0 Then
            ' The thread has never been started. Start it.
            m_Thread.Start()
        Else
            ' The thread is paused. Resume it.
            m_Thread.Resume()
        End If

        btnStopThread.Enabled = True
        btnStartThread.Enabled = False
    End Sub

    Private Sub btnStopThread_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStopThread.Click
        ' Suspend the thread.
        Debug.WriteLine("Suspending thread")
        m_Thread.Suspend()

        btnStopThread.Enabled = False
        btnStartThread.Enabled = True
    End Sub
End Class

' This class's Run method displays a count in the Output window.
Public Class Counter
    ' The form that owns the Value variable.
    Private m_MyForm As Form1

    Public Sub New(ByVal my_form As Form1)
        m_MyForm = my_form
    End Sub

    ' Count off seconds in the Output window.
    Public Sub Run()
        Try
            Do
                ' Wait 1 second.
                Thread.Sleep(1000)

                ' Lock the form object. This doesn't do anything
                ' to the form, it just means no other thread can
                ' lock the form object until we release the lock.
                SyncLock m_MyForm
                    ' Increment the form's Value.
                    m_MyForm.Value += 1

                    ' Write the value.
                    Debug.WriteLine("Thread: " & m_MyForm.Value)
                End SyncLock
            Loop
        Catch ex As ThreadAbortException
            ' This happens when the main program aborts the thread.
            Debug.WriteLine("Thread aborting")
        Catch ex As Exception
            ' An unexpected error.
            Debug.WriteLine("Unexpected error in thread" & vbCrLf & _
                ex.Message)
        End Try
    End Sub
End Class